<?

class ot_reward_points{
 var $title, $output;

    function ot_reward_points() {
      $this->code = 'ot_reward_points';
      $this->title = MODULE_REWARD_POINTS_DISCOUNT_TITLE;
      $this->description = MODULE_REWARD_POINTS_DISCOUNT_DESCRIPTION;
      $this->enabled = MODULE_REWARD_POINTS_DISCOUNT_STATUS;
      $this->sort_order = MODULE_REWARD_POINTS_DISCOUNT_SORT_ORDER;
      $this->include_shipping = MODULE_REWARD_POINTS_DISCOUNT_INC_SHIPPING;
      $this->include_tax = MODULE_REWARD_POINTS_DISCOUNT_INC_TAX;
      $this->calculate_tax = MODULE_REWARD_POINTS_DISCOUNT_CALC_TAX;
      $this->table = MODULE_REWARD_POINTS_RATE;
      $this->credit_class = true;
      $this->output = array();
	  if(!isset($_SESSION['input_reward_points']) )
	  {$_SESSION['input_reward_points'] = 0;}
    }

    function process() {
		global $order, $ot_subtotal, $currencies, $db;
		$od_amount = $this->calculate_credit($this->get_order_total());
		if ($od_amount>0) {
			$this->deduction = $od_amount;
			$this->output[] = array('title' => $this->title . ':',
								  'text' => '-' . $currencies->format($od_amount),
								  'value' => $od_amount);
			$order->info['total'] = $order->info['total'] - $od_amount;
			if ($this->sort_order < $ot_subtotal->sort_order) {
				$order->info['subtotal'] = $order->info['subtotal'] - $od_amount;
			}
		}
    }
   
	function credit_selection() {
		global $db;
		$selection = array('id' => $this->code,
							   'module' => $this->title,
							   'redeem_instructions' => MODULE_ORDER_TOTAL_COUPON_REDEEM_INSTRUCTIONS.($_SESSION['input_reward_points'] != 0 ? MODULE_ORDER_TOTAL_COUPON_REMOVE_INSTRUCTIONS : ''),
							   'fields' => array(array('title' => ($_SESSION['input_reward_points'] != 0 ? MODULE_ORDER_TOTAL_COUPON_TEXT_CURRENT_CODE . '<a href="javascript:couponpopupWindow(\'' . zen_href_link(FILENAME_POPUP_COUPON_HELP, 'cID=' . $_SESSION['input_reward_points']) . '\')">' . $_SESSION['input_reward_points'] . '</a><br />' : '') . MODULE_ORDER_TOTAL_COUPON_TEXT_ENTER_CODE,
													   'field' => zen_draw_input_field('input_reward_points', '', 'id="disc-'.$this->code.'" onchange="submitFunction(0,0)"'),
													   'tag' => 'disc-'.$this->code
							   )));
		return $selection;
	}
	
	function apply_credit(){
		global $db,$insert_id;
		$db->Execute("insert into ".TABLE_CS_CUSTOMERS_POINTS." 
		values('NULL','".$insert_id."','-".$_SESSION['input_reward_points']."','".$this->table."')");
		return false;
	}
	
	function update_credit_account($i) {
		global $db,$insert_id,$order;
			
		$products_points = $db->Execute("Select products_points from ".TABLE_CS_PRODUCTS_POINTS." where products_id = ".(int)$order->products[$i]['id']);
		$db->Execute("insert into ".TABLE_CS_CUSTOMERS_POINTS." 
		values('NULL','".$insert_id."','".$products_points->fields['products_points']."',".$this->table.")");
		return false;
	}
	
	function collect_posts() {
		global $db,$messageStack;

	// remove discount coupon by request
		if (isset($_POST['input_reward_points']) && $_POST['input_reward_points'] == 0 && $_SESSION['input_reward_points']!= 0)	
		{
			$messageStack->add_session('checkout_payment', TEXT_REMOVE_REWARD_POINTS, 'caution');
		}
		
		if(isset($_POST['input_reward_points']) && $_POST['input_reward_points'] != 0){
			$input_reward_points = $_POST['input_reward_points'];
			
			$customers_points = $db->Execute("SELECT sum(ccp.points) as points from ".TABLE_CS_CUSTOMERS_POINTS." ccp inner join ".TABLE_ORDERS_PRODUCTS." op on ccp.orders_products_id = op.orders_products_id inner join ".TABLE_ORDERS." o on op.orders_id = o.orders_id WHERE o.customers_id = ".$_SESSION['customer_id']);

			if( $customers_points->fields['points'] < $input_reward_points){
				$input_reward_points = $customers_points->fields['points'];
			}
			$_SESSION['input_reward_points'] = $input_reward_points;
		}
	}
	function clear_posts(){
	return false;
	}
  function pre_confirmation_check($order_total) {
    global $order;
    $od_amount = $this->calculate_credit($order_total);
    return $od_amount;
  }
   
  function calculate_credit($amount) {
    global $order;
    $od_amount=0;
    $od_pr = MODULE_REWARD_POINTS_RATE*$_SESSION['input_reward_points'];
	

// Calculate tax reduction if necessary
    if($this->calculate_tax == 'true') {
// Calculate main tax reduction
      $tod_amount = round($order->info['tax']*10)/10*$od_pr;
      $order->info['tax'] = $order->info['tax'] - $tod_amount;
// Calculate tax group deductions
      reset($order->info['tax_groups']);
      while (list($key, $value) = each($order->info['tax_groups'])) {
        $god_amount = round($value*10)/10*$od_pr;
        $order->info['tax_groups'][$key] = $order->info['tax_groups'][$key] - $god_amount;
      }  
    }
    $od_amount = $od_pr;
//    $od_amount = $od_amount + $tod_amount;
// maniac101 above line was adding tax back into discount incorrectly for me
    return $od_amount;
  }


  function get_order_total() {
    global  $order, $cart, $db;
    $order_total = $order->info['total'];
// Check if gift voucher is in cart and adjust total
//    $products = $cart -> get_products();
    for ($i=0; $i<sizeof($products); $i++) {
      $t_prid = zen_get_prid($products[$i]['id']);
      $gv_query = $db->Execute("select products_price, products_tax_class_id, products_model from " . TABLE_PRODUCTS . " where products_id = '" . $t_prid . "'");
      //$gv_result = zen_db_fetch_array($gv_query);
      if (ereg('^GIFT', addslashes($gv_result['products_model']))) { 
        $qty = $cart->get_quantity($t_prid);
        $products_tax = zen_get_tax_rate($gv_result['products_tax_class_id']);
        if ($this->include_tax =='false') {
           $gv_amount = $gv_result['products_price'] * $qty;
        } else {
          $gv_amount = ($gv_result['products_price'] + zen_calculate_tax($gv_result['products_price'],$products_tax)) * $qty;
        }
        $order_total=$order_total - $gv_amount;
      }
    }
    if ($this->include_tax == 'false') $order_total=$order_total-$order->info['tax'];
    if ($this->include_shipping == 'false') $order_total=$order_total-$order->info['shipping_cost'];
    return $order_total;
  }   
    
    
    
    function check() {
	  global $db;
      if (!isset($this->check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_REWARD_POINTS_DISCOUNT_STATUS'");
        $this->check = $check_query->RecordCount();
      }

      return $this->check;
    }

    function keys() {
      return array('MODULE_REWARD_POINTS_DISCOUNT_STATUS', 'MODULE_REWARD_POINTS_DISCOUNT_SORT_ORDER','MODULE_REWARD_POINTS_RATE', 'MODULE_REWARD_POINTS_DISCOUNT_INC_SHIPPING', 'MODULE_REWARD_POINTS_DISCOUNT_INC_TAX','MODULE_REWARD_POINTS_DISCOUNT_CALC_TAX');
    }

    function install() {
      global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Display Total', 'MODULE_REWARD_POINTS_DISCOUNT_STATUS', 'true', 'Do you want to enable the Order Discount?', '6', '1','zen_cfg_select_option(array(\'true\', \'false\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_REWARD_POINTS_DISCOUNT_SORT_ORDER', '250', 'Sort order of display.', '6', '2', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Include Shipping', 'MODULE_REWARD_POINTS_DISCOUNT_INC_SHIPPING', 'false', 'Include Shipping in calculation', '6', '3', 'zen_cfg_select_option(array(\'true\', \'false\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Include Tax', 'MODULE_REWARD_POINTS_DISCOUNT_INC_TAX', 'true', 'Include Tax in calculation.', '6', '4','zen_cfg_select_option(array(\'true\', \'false\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('Calculate Tax', 'MODULE_REWARD_POINTS_DISCOUNT_CALC_TAX', 'true', 'Re-calculate Tax on discounted amount.', '6', '5','zen_cfg_select_option(array(\'true\', \'false\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Points Rate', 'MODULE_REWARD_POINTS_RATE', '10', 'Set the rate per point', '6', '6', now())");
    }

    function remove() {
      $keys = '';
      $keys_array = $this->keys();
      for ($i=0; $i<sizeof($keys_array); $i++) {
        $keys .= "'" . $keys_array[$i] . "',";
      }
      $keys = substr($keys, 0, -1);

      global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in (" . $keys . ")");
    }
}

?>